#ifdef BCPP50
#include <owl/window.h>
#endif
#ifdef BB50
#include <vcl.h>
#pragma hdrstop
#endif

#include <math.h>
#include <stdio.h>
#include "samples.h"

#ifdef BCPP50
typedef TArrayAsVector<TMiernik *> TMierniki;
TMierniki *mierniki = 0;
#endif
bool komunikat = true;

#ifdef BB50
TMiernik* MaWlasciwyID(TObjectList* lista, int id) {
TMiernik* m;
int i=0;
bool found = false;
   while (!found && (i<lista->Count)) {
        m = (TMiernik*)(lista->Items[i]);
	found = m->GetID() == id;
        i++;
        };
   if (found) return m;
   return 0;
};

void ZapiszMierniki(TObjectList* lista) {
   for (int i=0;i<lista->Count;i++)
        ((TMiernik*)(lista->Items[i]))->SaveSamples();
   };

void OdtworzMierniki(TObjectList* lista) {
   for (int i=0;i<lista->Count;i++)
        ((TMiernik*)(lista->Items[i]))->RestoreSamples();
   };
#endif



/****   czesc wynikajaca z natury programowania i specyfiki TCada ****/
#ifdef BCPP50
__fastcall TMiernik::TMiernik(int id, double f_harm) {
#endif
#ifdef BB50
__fastcall TMiernik::TMiernik(int id, double f_harm) : TObject() {
#endif

	Probki = new SampleRecord[NumberOfSamples];
   ID = id;
   IndeksPierwszej = IndeksPierwszejWCalce = 0;
   IndeksOstatniej = -1;
   calkaRMS = calkaAV = calkaRMS_ = calkaAV_ = 0;
   calkaF_A = calkaF_B = calkaF_A_ = calkaF_B_ = 0;
   f = f_harm;	//ustawienie czestotliwosci interesujacej harmonicznej
};

__fastcall TMiernik::~TMiernik() {

	delete(Probki);
};


void TMiernik::SaveSamples() {

  	IndeksOstatniej_			= IndeksOstatniej;
   IndeksPierwszej_ 			= IndeksPierwszej;
   IndeksPierwszejWCalce_	= IndeksPierwszejWCalce;
   calkaRMS_ 					= calkaRMS;
   calkaAV_ 					= calkaAV;
   calkaF_A_ = calkaF_A;
   calkaF_B_ = calkaF_B;
};

void TMiernik::RestoreSamples() {

  	IndeksOstatniej 	= IndeksOstatniej_;
   IndeksPierwszej 	= IndeksPierwszej_;
   IndeksPierwszejWCalce 	= IndeksPierwszejWCalce_;
   calkaRMS 			= calkaRMS_;
   calkaAV 				= calkaAV_;
   calkaF_A = calkaF_A_;
   calkaF_B = calkaF_B_;
};

/****   koniec czesci wynikajaca z natury programowania i specyfiki TCada ****/

int TMiernik::IndeksNastepnej(int poprzednia) {

if ((poprzednia == IndeksOstatniej)  || (poprzednia < 0)) return -1;
int indeks = poprzednia + 1;
	if (indeks >= NumberOfSamples) indeks -= NumberOfSamples;
   return indeks;
};

int TMiernik::IndeksPoprzedniej(int nastepna) {

if  ((nastepna == IndeksPierwszej) || (nastepna < 0)) return -1;
int indeks = nastepna - 1;
	if (indeks < 0) indeks += NumberOfSamples;
   return indeks;
};

int TMiernik::IndeksProbkiwgChwili(double time) {

double	tmin = Probki[IndeksPierwszej].time;
double	tmax = Probki[IndeksOstatniej].time;
	if ((time < tmin) || (time > tmax)) return -1;
double lp = IndeksOstatniej - IndeksPierwszej;
	if (lp < 0) lp += NumberOfSamples;

int indeks = IndeksOstatniej - (tmax-time)/(tmax-tmin)*lp;
   if (indeks < 0) indeks += NumberOfSamples;
//znowu jakies problemy z obcieciem numerycznym, petla "while" je zalatwia
	while ((Probki[indeks].time < time) && (indeks>=0))
   	indeks = IndeksNastepnej(indeks);
   if ((Probki[indeks].time - time) <
   	 (time - Probki[IndeksPoprzedniej(indeks)].time))
		return indeks;
   return IndeksPoprzedniej(indeks);
};

bool TMiernik::JestStarsza(int badana, int indeks) {
	if ((badana < 0) || (indeks < 0)) return false;
	return (Probki[badana].time < Probki[indeks].time);
};

void TMiernik::OperacjaNaCalce(
	double &calka,
   double v, double h, int tryb, double wspnik) {

   switch (tryb) {
   	case ID_RMS:calka = calka + wspnik*v*v*h;break;
      case ID_AV:
      case ID_FA: 
      case ID_FB: calka = calka + wspnik*v*h;break;
      };
};

#define pi M_PI

void TMiernik::ObliczCalki(double Period) {

//chwila zapamietana w ostatniej probce
double lt = Probki[IndeksOstatniej].time;
//indeks probki starszej od ostatniej o okres ("Period")
int iof = IndeksProbkiwgChwili(lt  - Period);
//indeks przedostatniej zapamietanej probki
int ib = IndeksPoprzedniej(IndeksOstatniej);
int przed_ib;

	if (iof < 0) {// probki iof nie ma jeszcze w tablicy
      if (ib<0) {//kompletny start pracy
      	calkaRMS = 0;
         calkaAV = 0;
         IndeksPierwszejWCalce = IndeksPierwszej;
         }
      	else {
         // dodanie nowego slupka
         OperacjaNaCalce(calkaRMS,Probki[IndeksOstatniej].value,
      		 				lt - Probki[ib].time, ID_RMS, 1.0);
         OperacjaNaCalce(calkaAV,Probki[IndeksOstatniej].value,
      		 				lt - Probki[ib].time, ID_AV, 1.0);
         OperacjaNaCalce(calkaF_A,
         					Probki[IndeksOstatniej].value*
                        cos(f*2.0*pi*Probki[IndeksOstatniej].time),
      		 				lt - Probki[ib].time, ID_FA, 1.0);
         OperacjaNaCalce(calkaF_B,
         					Probki[IndeksOstatniej].value*
                        sin(f*2.0*pi*Probki[IndeksOstatniej].time),
      		 				lt - Probki[ib].time, ID_FB, 1.0);
         };
      } else {
      // dodanie nowego slupka
      OperacjaNaCalce(calkaRMS,Probki[IndeksOstatniej].value,
						lt - Probki[ib].time, ID_RMS, 1.0);
      OperacjaNaCalce(calkaAV,Probki[IndeksOstatniej].value,
						lt - Probki[ib].time, ID_AV, 1.0);
      OperacjaNaCalce(calkaF_A,
     					Probki[IndeksOstatniej].value*
                  cos(f*2.0*pi*Probki[IndeksOstatniej].time),
  		 				lt - Probki[ib].time, ID_FA, 1.0);
      OperacjaNaCalce(calkaF_B,
    					Probki[IndeksOstatniej].value*
                  sin(f*2.0*pi*Probki[IndeksOstatniej].time),
  		 				lt - Probki[ib].time, ID_FB, 1.0);

      // operacje na poczatkowej czesci calki
      /****************************************
      P.1
      Jezeli okres calkowania sie nie zwiekszyl, to calkaX powinna
      zostac uwolniona od wszystkich probek ("slupkow") ponizej indeksu "iof".
      P.2
      Jezeli okres calkowania sie zwiekszyl, to trzeba ja uzupelnic o
      brakujace od "iof" do "IndeksPierwszejWCalce".
      UWAGA Slupki sa zliczane od "f(IndeksPierwszejWCalce+1)*h"
      *****************************************/
      // od IndeksPierwszejWCalce+1 zaczynalo sie calkowanie
      przed_ib = IndeksPierwszejWCalce;
      ib = IndeksNastepnej(przed_ib);
      // P.1
      // odejmowanie "przestarzalych" slupkow
      while (JestStarsza(przed_ib,iof)) {
      	OperacjaNaCalce(calkaRMS,Probki[ib].value,
						Probki[ib].time - Probki[przed_ib].time, ID_RMS, -1.0);
      	OperacjaNaCalce(calkaAV,Probki[ib].value,
						Probki[ib].time - Probki[przed_ib].time, ID_AV, -1.0);
         OperacjaNaCalce(calkaF_A,
     					Probki[ib].value*cos(f*2.0*pi*Probki[ib].time),
  		 				Probki[ib].time - Probki[przed_ib].time, ID_FA, -1.0);
         OperacjaNaCalce(calkaF_B,
     					Probki[ib].value*sin(f*2.0*pi*Probki[ib].time),
  		 				Probki[ib].time - Probki[przed_ib].time, ID_FB, -1.0);


         przed_ib = ib;
         ib = IndeksNastepnej(ib);
         };
      //koniec P.1
      // P.2
      ib = IndeksPierwszejWCalce;
      przed_ib = IndeksPoprzedniej(ib);
      // dodawanie brakujacych slupkow
      while (JestStarsza(iof,ib)) {
      	OperacjaNaCalce(calkaRMS,Probki[ib].value,
      			 Probki[ib].time - Probki[przed_ib].time, ID_RMS, 1.0);
         OperacjaNaCalce(calkaAV,Probki[ib].value,
      			 Probki[ib].time - Probki[przed_ib].time, ID_AV, 1.0);
         OperacjaNaCalce(calkaF_A,
   				 Probki[ib].value*cos(f*2.0*pi*Probki[ib].time),
      		 	 Probki[ib].time - Probki[przed_ib].time, ID_FA, 1.0);
         OperacjaNaCalce(calkaF_B,
         		 Probki[ib].value*sin(f*2.0*pi*Probki[ib].time),
      		 	 Probki[ib].time - Probki[przed_ib].time, ID_FB, 1.0);

         ib = przed_ib;
         przed_ib = IndeksPoprzedniej(przed_ib);
         };
      //koniec P.2 */
      IndeksPierwszejWCalce = iof;
      };
};

double TMiernik::GetParameter(int mode) {

if (IndeksPierwszej == IndeksOstatniej) //start
   	return 0;
if (IndeksPierwszejWCalce == IndeksOstatniej) //jakis inny balagan
   	return 0;
if ((IndeksPierwszej < 0) || (IndeksPierwszejWCalce < 0 ) ||
	 (IndeksOstatniej < 0)) //zbedne, ale nie zawadzi :-)
   	return 0;
double okres = Probki[IndeksOstatniej].time -
					Probki[IndeksPierwszejWCalce].time;

	if (okres <= 0) {
   	if (komunikat) komunikat = (MessageBox(GetActiveWindow(),
      	"okres ma warto mniejsz od zera(?!),\nustawiono ZERO jako warto parametru",
      	"miernik",MB_OKCANCEL | MB_ICONEXCLAMATION) != IDCANCEL);
      return(0);
      };
#ifdef prymityw
double x;int i;
#endif
double An,Bn,Cn;

   switch (mode) {
   	case ID_RMS:
      return sqrt(fabs(calkaRMS/okres));//fabs, bo sqrt glupieje przez zerze
   	case ID_AV:
         #ifdef prymityw
         // obliczenie AV w sposob prymitywny
         x =0;
         i=IndeksNastepnej(IndeksPierwszejWCalce);
         while ((i<=IndeksOstatniej) && (i>=0)) {
         	x += Probki[i].value*(Probki[i].time-Probki[IndeksPoprzedniej(i)].time);
            i = IndeksNastepnej(i);
            };
         return x/(Probki[IndeksOstatniej].time-Probki[IndeksPierwszejWCalce].time);
         #else
         return calkaAV/okres;
         #endif
      case ID_FAB:
      	An = 2.0/okres*calkaF_A;
         Bn = 2.0/okres*calkaF_B;
         Cn = sqrt(An*An+Bn*Bn);
         return Cn;
      default: return 0;
      };
};

int TMiernik::GetID() {return ID;};

SampleRecord TMiernik::GetProbe(int index) {return Probki[index];};

int TMiernik::GetLastIndex(){return IndeksOstatniej;};

void TMiernik::DopiszProbke(double v, double t, double Period){
char s[200];

bool start = (IndeksOstatniej < 0);
   IndeksOstatniej ++;
   if (IndeksOstatniej >= NumberOfSamples) IndeksOstatniej = 0;
   if ((IndeksOstatniej == IndeksPierwszej) && (!start)){
   	IndeksPierwszej++;
      if (IndeksPierwszej >= NumberOfSamples) IndeksPierwszej = 0;
      if (((t - Probki[IndeksPierwszej].time) < Period) && komunikat) {
      	strcpy(s,"Jest konieczne zwikszenie rozmiaru tablicy prbek\n");
         strcat(s,"(\"#define NumberOfSamples\" w pliku samples.h)\n");
         strcat(s,"Czy wywietla nadal ten komunikat?");
         komunikat =
            	(MessageBox(GetActiveWindow(),s,"bd",MB_YESNO | MB_ICONQUESTION)
                == IDYES);
         };
      };
   Probki[IndeksOstatniej].value = v;
   Probki[IndeksOstatniej].time  = t;
   // aktualizacja calek (RMS i AV)
   ObliczCalki(Period);
};

/** koniec definicji obiektu TMiernik **/

int MaWlasciwyID(TMiernik * const &m, void *id) {

	return int(m->GetID() == *(int*)id);
};

//operacje na tablicy probek Probki[nr]
#ifdef BCPP50
bool DopiszProbkeDoMiernika( //ustawia true jezeli pobrano probke
	int &nr,
   double v,
   double t,
   double ResTime,	// w USER a2
   double f_harm,		// w USER a3
   double Period		// w USER x3
   ) {
#endif
#ifdef BB50
bool DopiszProbkeDoMiernika( //ustawia true jezeli pobrano probke
	int &nr,
   double v,
   double t,
   double ResTime,	// w USER a2
   double f_harm,		// w USER a3
   double Period,		// w USER x3
   TObjectList *mierniki
   ) {
#endif
double LastProbeTime;
double resolution;
bool result;
#ifdef BCPP50
TMiernik **ptr, *m;
#endif
#ifdef BB50
TMiernik *m;
#endif

   result = false;
   /******  ustalenie miernika wg "nr", ewentualna inicjacje ******/
   #ifdef BCPP50
   if (!mierniki)		// kompletny start
   	mierniki = new TMierniki(0,0,sizeof(TMiernik *));
   ptr = (nr > 0) ? (mierniki->FirstThat(MaWlasciwyID, &nr)) : 0;
   if (!ptr) {
        if (mierniki->GetItemsInContainer())  // ID nastepnego miernika
                nr = mierniki->operator[](mierniki->GetItemsInContainer()-1)->GetID()+1;
                else nr = 1;  // ID pierwszego miernika
        mierniki->Add(m = new TMiernik(nr,f_harm));  // inicjacja nowego miernika
        } else m = (TMiernik*)*ptr;
   #endif
   #ifdef BB50
   if (!mierniki)		// kompletny start
   	mierniki = new TObjectList();
   m = (nr > 0) ? MaWlasciwyID(mierniki,nr) : 0;
   if (!m) {
        if (mierniki->Count)  // ID nastepnego miernika
                nr = ((TMiernik*)(mierniki->Items[mierniki->Count-1]))->GetID()+1;
                else nr = 1;  // ID pierwszego miernika
        mierniki->Add(m = new TMiernik(nr,f_harm));  // inicjacja nowego miernika
        };
   #endif

   /******  koniec lokalizowania miernika *m ******/

   // sprawdzenie rozdzielczosci
   if (ResTime < MinimalResolution)	resolution = MinimalResolution;
   	else resolution = ResTime;

   // chwyt na wykrycie startu
   if (m->GetLastIndex() < 0) LastProbeTime = t - 2*resolution;// :-)
   	else LastProbeTime = m->GetProbe(m->GetLastIndex()).time;

   //if ((t - LastProbeTime) >= resolution) {// nie dziala, chyba przez obciecia!
  	if ((t - LastProbeTime) >= (resolution*0.999)) {
   	m->DopiszProbke(v,t,Period);
      result = true;
      };
   return  result;
};

#ifdef BCPP50
void DeleteSamples() {
#endif
#ifdef BB50
void DeleteSamples(TObjectList* &mierniki) {
#endif

   if (mierniki) delete mierniki;
};

void ZapiszMierniki(TMiernik * &m, void *) {m->SaveSamples();};

#ifdef BCPP50
void SaveSamples() {
#endif
#ifdef BB50
void SaveSamples(TObjectList* mierniki) {
#endif
if (mierniki)
   #ifdef BCPP50
   mierniki->ForEach(ZapiszMierniki,0);
   #endif
   #ifdef BB50
   ZapiszMierniki(mierniki);
   #endif
};

void OdtworzMierniki(TMiernik * &m, void *) {m->RestoreSamples();};

#ifdef BCPP50
void RestoreSamples() {
#endif
#ifdef BB50
void RestoreSamples(TObjectList* mierniki) {
#endif
if (mierniki)
   #ifdef BCPP50
   mierniki->ForEach(OdtworzMierniki,0);
   #endif
   #ifdef BB50
   OdtworzMierniki(mierniki);
   #endif
};

#ifdef BCPP50
double GetParameter(int id, int mode) {
#endif
#ifdef BB50
double GetParameter(TObjectList *mierniki, int id, int mode) {
#endif

if (!mierniki) return 0;

   #ifdef BCPP50
TMiernik **ptr, *m;
   ptr = (mierniki->FirstThat(MaWlasciwyID, &id));
   if (!ptr) return 0;
   m = (TMiernik*)*ptr;
   #endif

   #ifdef BB50
TMiernik *m;
   m = MaWlasciwyID(mierniki,id);
   if (!m) return 0;
   #endif

   return m->GetParameter(mode);
};

