library user;
uses SysUtils;

procedure SaveUserToys;cdecl;export;
begin

end;

procedure RestoreUserToys;cdecl;export;
begin

end;

procedure user_1(
  var y0: double;
  x0, x1, x2, x3, time, step: double;
  var a1, a2, a3, a4, a5, a6: double;
  var x:double);cdecl;export;

begin
case round(a1) of
     0:y0 := 0;
     1:(**********************************************************
       	multiwibrator monostabilny o nastepujacych cechach:
       	1. wzbudzany zboczem narastajacym "x0" takim, ze dx0/dt>3/h,
       	   przy czym poprzednia wartosc "x0" jest zapamietywana jako "a3",
	2. czas trwania impusu ustawiany jako a2[s],
	3. poziom niski ma wartosc "a4", wysoki "a5",
	4. ostatnia chwila wzbudzenia jest zapamietywana jako "x"
       *)
       begin
       if ( (x <= time) and ((x + a2) >= time) )
          then
          //trwa wczesniej wzbudzony impuls
          y0 := a5
	  else
          // sprawdzenie zbocza
          begin
          if ((x0 - a3) > 3) then
             begin
             // jest narastajace -> wzbudzenie
	     x := time;
	     y0 := a5;
	     end
             else
	     //nie ma impulsu
	     y0 := a4;
          end;
       a3 := x0;
       end;
       (*********************************************************)
     else y0 := 0;
     end;
end;

procedure user_2(
  var y0, y1: double;
  x0, x1, x2, x3, time, step: double;
  var a1, a2, a3, a4, a5, a6: double;
  var x:double);cdecl;export;
begin
y0 := 0;
y1 := 0;
end;

procedure user_3(
  var y0, y1, y2: double;
  x0, x1, x2, x3, time, step: double;
  var a1, a2, a3, a4, a5, a6: double;
  var x:double);cdecl;export;
begin
y0 := 0;
y1 := 0;
y2 := 0;
end;

//UZUPENIENIE OD WERSJI Z GRUDNIA '2004

type
ArrayOfDouble = array [0..19] of double;
pArrayOfDouble = ^ArrayOfDouble;
(****************************************************
bez wzgldu na deklaracj typu pArrayOfDouble
rozmiary tablic odpowiadaj rodzajowi bloku USER:
10/6  - x[0..9], a[0..12], s[0..5], y[0..5];
10/10 - x[0..9], a[0..12], s[0..7], y[0..9];
20/20 - x[0..19], a[0..12], s[0..7], y[0..19].

Sugeruje si, by parametr a[0] uywa jako rodzaj (identyfikator) funkcji.
Bloki USER mog bezporednio sterowa cznikami.
W takim przypadku sterujcemu wyjciu naley przypisa warto nisk okreslon
przez a[1] bd wysok - okreslon przez a[2]
Tablice "a", "s" i "y" mona traktowa jako zmienne przez ca symulacj.
Tablica s moe zosta przepisana do warunkw pocztkowych przez
"Aktualizacj stanu ukadu""
****************************************************)
procedure user_MN(
 x, a, s: pArrayOfDouble;
 time, step: double;
 y:pArrayOfDouble);cdecl;export;
var i, mode:integer;
    yL,yH:double;
begin
mode := round(a^[0]);
yL   := a^[1];
yH   := a^[2];
case mode of
     1:
     //przepisanie wej na wyjcia dla bloku 20/20
     for i:=0 to 19 do y^[i] := x^[i];
     else
     //ustawienie na "1" wyj od 0 do 5
     for i:=0 to 5 do y^[i] := 1;
     end;
end;

exports
  SaveUserToys,RestoreUserToys,
  user_1, user_2,user_3,user_MN;

//KONIEC UZUPENIENIA OD WERSJI Z GRUDNIA '2004

//{$R *.RES}
{$R VERINFO.RES}

begin
end.

